///////////////////////////////////////////////////////////////////////////////
// Name:        gui.h
// Purpose:     Header for gui code
// Author:      Chad Rempp
// Modified by: Chad Rempp
// Created:     05-20-03
// Copyright:   (c) 2003 Chad Rempp
// Licence:     GNU Public License (hey it's what all my friends are doing)
///////////////////////////////////////////////////////////////////////////////

#ifndef _GUI_H
#define _GUI_H

#include <wx/wx.h>

///////////////////////////////////////////////////////////////////////////////
// wxApp Class          NGuiApp
///////////////////////////////////////////////////////////////////////////////

class NGuiApp: public wxApp
{
  public:
      virtual bool OnInit();
};


///////////////////////////////////////////////////////////////////////////////
// wxFrame Class        mainFrame
///////////////////////////////////////////////////////////////////////////////
class mainFrame: public wxFrame
{
  public:
      mainFrame(const wxString &title, const wxPoint &pos, const wxSize &size,
                long style);
      void OnQuit(wxCommandEvent &event);
      void OnNewPerceptron(wxCommandEvent &event);
      void OnNewMultiPercp(wxCommandEvent &event);

  private:
      // Any class wishing to process wxWindows events must use this macro
      DECLARE_EVENT_TABLE()
};

///////////////////////////////////////////////////////////////////////////////
// wxDialog Class        netDialog
///////////////////////////////////////////////////////////////////////////////
class netDialog: public wxDialog
{
    public:
        netDialog(wxWindow *parent, wxWindowID id, const wxString &title,
                  const wxPoint& pos = wxDefaultPosition,
                  const wxSize& size = wxDefaultSize,
                  long style = wxDEFAULT_DIALOG_STYLE);
        wxButton *btn_newinput;
        wxButton *btn_delinput;
        wxButton *btn_setwghts;
        wxButton *btn_train;
        wxButton *btn_run;
        wxButton *btn_setdesrd;
        wxButton *btn_showdiag;
        wxButton *btn_quit;
        wxTextCtrl *txt_bias;
        wxTextCtrl *txt_squashval;
        wxStaticText *stc_bias;
        wxStaticText *stc_squashval;
   private:
        void OnNewInput(wxCommandEvent &event);
        void OnDelInput(wxCommandEvent &event);
        void OnSetWghts(wxCommandEvent &event);
        void OnSetDesrd(wxCommandEvent &event);
        void OnTrain(wxCommandEvent &event);
        void OnRun(wxCommandEvent &event);
        void OnShowDiag(wxCommandEvent &event);
        void OnQuit(wxCommandEvent &event);
        DECLARE_EVENT_TABLE()
};

///////////////////////////////////////////////////////////////////////////////
// wxGLCanvas Class        netGLCanvas
///////////////////////////////////////////////////////////////////////////////
//class netGLCanvas: public wxGLCanvas
//{
//    friend class mainFrame;
//    public:
//        netGLCanvas(wxWindow *parent, const wxWindowID id = -1,
//            const wxPoint& pos = wxDefaultPosition, const wxSize& = wxDefaultSize,
//            long style = 0,const wxString& name = "Net Diagram");
//        void Render(void);
//        void InitGL(void);
//    private:
//        DECLARE_EVENT_TABLE()
//};

// IDs for the menu command
enum
{
   mainFrame_Quit,
   mainFrame_NewPerceptron,
   mainFrame_NewMultiPercp,
   netDialog_NEWINPUT_BTN,
   netDialog_DELINPUT_BTN,
   netDialog_SETWGHTS_BTN,
   netDialog_SETDESRD_BTN,
   netDialog_TRAIN_BTN,
   netDialog_RUN_BTN,
   netDialog_SHOWDIAG_BTN,
   netDialog_QUIT_BTN,
   netDialog_BIAS_TXT,
   netDialog_SQUASHVAL_TXT
};

DECLARE_APP(NGuiApp)

#endif   // _GUI_H
