///////////////////////////////////////////////////////////////////////////////
// Name:        unnamed.cpp
// Purpose:     
// Author:      
// Modified by:
// Created:     
// Copyright:   
// Licence:     
///////////////////////////////////////////////////////////////////////////////

#include <wx/wxprec.h>
#include <wx/glcanvas.h>
#include <gl/glu.h>

#ifndef WX_PRECOMP
   #include <wx/wx.h>
#endif

GLfloat light_ambient[4] = {0.0, 0.0, 1.0, 1.0};
GLfloat light_diffuse[4] = {1.0, 1.0, 1.0, 1.0};
GLfloat light_specular[4] = {1.0, 1.0, 1.0, 1.0};
GLfloat light_position[4] = {1.0, 1.0, 1.0, 0.0};
GLUquadricObj *gl_neuron;
float neuron_radius = 1.0;
int neuron_stacks = 10;
int neuron_slices = 10;
void reshape(int width, int height);

// The main Application

class MainApp: public wxApp
{
  public:
      virtual bool OnInit();
};

class NetGLCanvas: public wxGLCanvas
{
    public:
    NetGLCanvas(wxWindow *parent, const wxWindowID id = -1,
                const wxPoint& pos = wxDefaultPosition,
                const wxSize& size = wxDefaultSize, long style = 0,
                const wxString& name = "netcanvas");
    void InitGL(void);
    void Render(void);
    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void OnEraseBackground(wxEraseEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnKeyUp(wxKeyEvent& event);
    void OnEnterWindow(wxMouseEvent& event);
    void Rotate(GLfloat deg_horiz, GLfloat deg_vert);

    private:
    bool gl_init;

    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(NetGLCanvas, wxGLCanvas)
    EVT_SIZE(NetGLCanvas::OnSize)
    EVT_PAINT(NetGLCanvas::OnPaint)
    EVT_ERASE_BACKGROUND(NetGLCanvas::OnEraseBackground)
    EVT_KEY_DOWN(NetGLCanvas::OnKeyDown)
    EVT_KEY_UP(NetGLCanvas::OnKeyUp)
    EVT_ENTER_WINDOW(NetGLCanvas::OnEnterWindow)
END_EVENT_TABLE();

IMPLEMENT_APP(MainApp)

bool MainApp::OnInit()
{
    wxFrame *frame = new wxFrame((wxFrame *)NULL, -1, "OpenGL Test", wxPoint (100, 100), wxSize(600, 600));

    NetGLCanvas *testcanvas = new NetGLCanvas(frame, -1, wxPoint(0, 0), wxSize(500,500));
    testcanvas->SetCurrent();
    frame->Show(TRUE);

    return TRUE;
}

NetGLCanvas::NetGLCanvas(wxWindow *parent, wxWindowID id,
                         const wxPoint& pos, const wxSize& size, long style,
                         const wxString& name):
                         wxGLCanvas(parent, (wxGLCanvas*) NULL, id, pos, size, style, name)
{
    gl_init=FALSE;
}

void NetGLCanvas::InitGL (void)
{
    SetCurrent();
    glClearColor(0.0, 0.0, 0.0, 0.0);

    // Set Lighting
    glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
    glLightfv(GL_LIGHT0, GL_POSITION, light_position);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glDepthFunc(GL_LESS);
    glEnable(GL_DEPTH_TEST);

    gluQuadricNormals(gl_neuron, GLU_SMOOTH);  // put these in init ??
    gluQuadricDrawStyle(gl_neuron, GLU_FILL);  // put these in init ??
    gluQuadricOrientation(gl_neuron,GLU_OUTSIDE);
    gluQuadricTexture(gl_neuron,GL_FALSE);
    gl_neuron = gluNewQuadric();
}

void NetGLCanvas::Render (void)
{
    SetCurrent();
    if (!gl_init)
    {
        InitGL();
        gl_init=TRUE;
    }

    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glFrustum(-1, 1, -1, 1, 1, 10);
    gluLookAt(2, 2, 2, 0, 0, 0, 0, 0, 1);
    glMatrixMode(GL_MODELVIEW);
    glColor3f(0.5,0.5,0.5);
    gluSphere(gl_neuron, neuron_radius, neuron_slices, neuron_stacks);
    glFlush();
    SwapBuffers();
}

void NetGLCanvas::OnEnterWindow(wxMouseEvent& event)
{
    SetFocus();
}

void NetGLCanvas::OnPaint(wxPaintEvent& event)
{
    Render();
}

void NetGLCanvas::OnSize(wxSizeEvent& event)
{
    wxGLCanvas::OnSize(event);

    int w, h;
    GetClientSize(&w, &h);
    SetCurrent();
    glViewport(0, 0, (GLint) w, (GLint) h);
}

void NetGLCanvas::OnEraseBackground(wxEraseEvent& event)
{
//  nothing
}

void NetGLCanvas::Rotate(GLfloat deg_horiz, GLfloat deg_vert)
{

}

void NetGLCanvas::OnKeyDown(wxKeyEvent& event)
{
}

void NetGLCanvas::OnKeyUp(wxKeyEvent& event)
{
}



